
function love.load()
    
	lg = love.graphics
	img = {}
	img.pig = lg.newImage('images/pig.png')
	
	local pixelcode = [[
	
	extern vec2 size;

	vec2 clamp(vec2 pos) {
		number x = pos.x;
		number y = pos.y;
		if (x < 0.0) x = 0.0;
		if (y < 0.0) y = 0.0;
		if (x > 1.0) x = 1.0;
		if (y > 1.0) y = 1.0;
		return vec2(x, y);
	}

	vec4 effect ( vec4 color, Image texture, vec2 tc, vec2 screen_coords ) {
		number distance = 1.0;
		number num = 0.0;
		
		vec4 clr;
		clr = Texel(texture, tc);
		if (clr.a > 0.0) {
			return clr;
		}
		
		number maxLength = length(vec2(6.0/size.x,6.0/size.y));
		
		for (number x = -6.0 ; x <= 6.0; x++)
		for (number y = -6.0 ; y <= 6.0; y++) {
			vec2 disp = vec2(x/size.x,y/size.y);
			clr = Texel(texture, clamp(tc+disp));
			if (clr.a > 0.0) {
				num = num + 1.0;
				number dist = length(disp) / maxLength;
				if (dist < distance) {
					distance = dist;
				}
			}
		}

		return vec4(color.r,color.g,color.b,1.0-distance);
	}
	]]

    shader = love.graphics.newShader(pixelcode)
	msgs = shader:getWarnings()
	shader:send('size',{300,235})
end

function love.draw()
    lg.print(msgs,10,10)
	lg.setColor({255,0,0,255})
	
    love.graphics.setShader(shader)
	lg.draw(img.pig,250,50)
    love.graphics.setShader()
	
	lg.setColor({255,255,255,255})
	lg.draw(img.pig,250,300)
	
end







